#include "common.h"

int main(void) {
	int xt,yt,t,k,M;
	int *x,*y;

	IN(BOUND(x,0,M),BOUND(y,0,M),M);

	k = 0;
	while (k < M) {
		xt = mul(x[k],cos(t))-mul(y[k],sin(t));
		yt = mul(x[k],sin(t))+mul(y[k],cos(t));
		x[k] = xt;
		y[k] = yt;
		k++;
	} 

	OUT(x,y,M);
}

void inverted()
{
	int *x_,*y_,xt_,yt_,t_,k_,M_;

	ASSUME(EQ("_x","_x_"));
	ASSUME(EQ("_y","_y_"));
	ASSUME(EQ("_M","_M_"));
	ASSUME(EQ("_t","_t_"));

	TS(k_);
	while (GUARD()) { 
		TS(xt_,yt_);
		TS(x_,y_,k_);
	} 

	OUT(BOUND(x_,0,M_),BOUND(y_,0,M_),M_);
}

#define MUL(a,b) CALL2("_mul",a,b)
#define COS(t) CALL1("_cos",t)
#define SIN(t) CALL1("_sin",t)

int params () {
	char* MODE = "invert";
	char* predicates = 
		LT("_k_","_M_") ", "
		GT("_k_","0") ", "
		;
	char* expressions = 
		"(0):int, "
		"(_k_ + 1):int, "
		ADD(MUL(SEL("_x_","_k_"),COS("_t_")),MUL(SEL("_y_","_k_"),SIN("_t_"))) ":int, "
		SUB(MUL(SEL("_y_","_k_"),COS("_t_")),MUL(SEL("_x_","_k_"),SIN("_t_"))) ":int, "
		UPD("_x_","_k_","_xt_") ":int*, "
		UPD("_y_","_k_","_yt_") ":int*, "
		;
	char *KINDS = "int; string; clock; ";
	char *TYPES = "int* _x_,_y_; "; // the rest default to Int
	char *SYMS =
		"_BOUND:int->int->int->int; "
		"_mul:int->int->int; "
		"_cos:int->int; "
		"_sin:int->int; "
		;

#include "rotate-axioms.h"

  char* NOTES = 
	  "ExpectedSolution : "
	  " &&& "
	  "Benchmark : tftp-data";
}