#include "common.h"
#define NULL "(_null 0)"
#define PAD "(_pad 0)"
#define APPEND(S1,S2) "(" S1 " _append " S2 ")"
#define DECODE(S) "(_decodeblock " S ")"
#define ENCODE(S) "(_encodeblock " S ")"
#define GET(a,i) "(" a " _get " i ")"

char *AXIOMS =
FORALL(QUANT14(y,d,dd,e,ee,a1,a2,a3,x1,x2,p1,p2,n1,n2), \
	   IMPLIES( \
			AND13( \
				EQ("d", DECODE("dd")), \
				EQ("dd", APPEND("a1","p2")), \
				EQ("a1", APPEND("a2","p1")), \
				EQ("a2", APPEND("a3","x2")), \
				EQ("a3", APPEND("n1","x1")), \
				EQ("e", ENCODE("ee")), \
				EQ("ee", APPEND("n2","y")), \
				EQ("n1", NULL), \
				EQ("n2", NULL), \
				EQ("x1", GET("e","0")), \
				EQ("x2", GET("e","1")), \
				EQ("p1",PAD), \
				EQ("p2",PAD) \
				), \
			AND4(EQ(GET("d","0"),"y"), NEQ("y",PAD), EQ(GET("d","1"),PAD), EQ(GET("d","2"),PAD)) \
			), \
	   PATT1(ANDPATT7(EQ("d", DECODE("dd")), \
				EQ("dd", APPEND("a1","p2")), \
				EQ("a1", APPEND("a2","p1")), \
				EQ("a2", APPEND("a3","x2")), \
				EQ("a3", APPEND("n1","x1")), \
				EQ("e", ENCODE("ee")), EQ("ee", APPEND("n2","y")))) \
	   ) "; "

FORALL(QUANT16(y0,y1,d,dd,e,e0,e1,a1,a2,a3,x1,x2,x3,p2,n1,n2), \
	   IMPLIES( \
			AND14( \
				EQ("d", DECODE("dd")), \
				EQ("dd", APPEND("a1","p2")), \
				EQ("a1", APPEND("a2","x3")), \
				EQ("a2", APPEND("a3","x2")), \
				EQ("a3", APPEND("n1","x1")), \
				EQ("e", ENCODE("e1")), \
				EQ("e1", APPEND("e0","y1")), \
				EQ("e0", APPEND("n2","y0")), \
				EQ("n1", NULL), \
				EQ("n2", NULL), \
				EQ("x1", GET("e","0")), \
				EQ("x2", GET("e","1")), \
				EQ("x3", GET("e","2")), \
				EQ("p2",PAD) \
				), \
			AND5(EQ(GET("d","0"),"y0"), NEQ("y0",PAD), EQ(GET("d","1"),"y1"), NEQ("y1",PAD), EQ(GET("d","2"),PAD)) \
			), \
	   PATT1(ANDPATT8(EQ("d", DECODE("dd")), \
				EQ("dd", APPEND("a1","p2")), \
				EQ("a1", APPEND("a2","x3")), \
				EQ("a2", APPEND("a3","x2")), \
				EQ("a3", APPEND("n1","x1")), \
				EQ("e", ENCODE("e1")), \
				EQ("e1", APPEND("e0","y1")), \
				EQ("e0", APPEND("n2","y0")))) \
	   ) "; "

FORALL(QUANT18(y0,y1,y2,d,dd,e,e0,e1,e2,a1,a2,a3,x1,x2,x3,x4,n1,n2), \
	   IMPLIES( \
			AND15( \
				EQ("d", DECODE("dd")), \
				EQ("dd", APPEND("a1","x4")), \
				EQ("a1", APPEND("a2","x3")), \
				EQ("a2", APPEND("a3","x2")), \
				EQ("a3", APPEND("n1","x1")), \
				EQ("e", ENCODE("e2")), \
				EQ("e2", APPEND("e1","y2")), \
				EQ("e1", APPEND("e0","y1")), \
				EQ("e0", APPEND("n2","y0")), \
				EQ("n1", NULL), \
				EQ("n2", NULL), \
				EQ("x1", GET("e","0")), \
				EQ("x2", GET("e","1")), \
				EQ("x3", GET("e","2")), \
				EQ("x4", GET("e","3")) \
				), \
			AND6(EQ(GET("d","0"),"y0"), NEQ("y0",PAD), EQ(GET("d","1"),"y1"), NEQ("y1",PAD), EQ(GET("d","2"),"y2"), NEQ("y2",PAD)) \
			), \
	   PATT1(ANDPATT9(EQ("d", DECODE("dd")), \
				EQ("dd", APPEND("a1","x4")), \
				EQ("a1", APPEND("a2","x3")), \
				EQ("a2", APPEND("a3","x2")), \
				EQ("a3", APPEND("n1","x1")), \
				EQ("e", ENCODE("e2")), \
				EQ("e2", APPEND("e1","y2")), \
				EQ("e1", APPEND("e0","y1")), \
				EQ("e0", APPEND("n2","y0")))) \
	   ) "; "
;
//EQ(LEN(NEW(1)), "1") "; " // single char initializer 1
//EQ(LEN(NEW(2)), "1") "; " // single char initializer 2
//EQ(LEN(NEW(0)), "0") "; " // empty string
//NEQ(NEW(1), NEW(2)) "; " 
//NEQ(NEW(0), NEW(1)) "; " 
//NEQ(NEW(0), NEW(2)) "; " // distinctness of characters
//EQ(CHAR(NEW(1),0), NEW(1)) "; " // single char strings 1
//EQ(CHAR(NEW(2),0), NEW(2)) "; " // single char strings 2
//// strlen of catone
//FORALL(QUANT2(P,Q), \
//	   EQ(LEN(CAT("P","Q")), INCR(LEN("P"))), \
//	   PATT1(LEN(CAT("P","Q")))) "; "
//// single chars match at least one in the domain of chars
//FORALL(QUANT2(A,k), \
//	   IMPLIES(NEQ(CHAR_A(k),NEW(1)), EQ(CHAR_A(k),NEW(2))), \
//	   PATT1(CHAR_A(k))) ";"
//// relates strlen and substring. required when differing lengths imply that string cannot be equal
//FORALL(QUANT3(A,k1,k2), \
//	   EQ( LEN(SUBSTR_A("k1","k2")), INCR(SUB("k2","k1")) ), \
//	   PATT1(SUBSTR_A("k1","k2"))) "; "
//// init case of single char strings
//FORALL(QUANT3(A,AA,X), \
//	   IMPLIES(AND(EQ("A", APPEND("AA","X")), EQ(NEW(0),"AA")), EQ("A","X")), \
//	   PATT1(ANDPATT( EQ("A", APPEND("AA","X")), EQ(NEW(0),"AA") ))) "; "
//// inductive case for string appends
//FORALL(QUANT5(X,Y,B,A,a), \
//	   IMPLIES( \
//		AND3( \
//		     EQ("X",SUBSTR_A("0","a")), \
//			 EQ("Y",APPEND("X","B")), \
//			 EQ("B", SUBSTR_A(INCR("a"),ADD("a",LEN("B")))) \
//		) , \
//		EQ("Y", SUBSTR_A("0", ADD("a",LEN("B")))) \
//	   ), \
//	   PATT1(ANDPATT(EQ("X", SUBSTR_A("0","a")), EQ("Y",APPEND("X","B")))) \
//) "; "				
//// inductive case for string appends with catone
//FORALL(QUANT6(X,Y,Q,C,A,a), \
//	   IMPLIES( \
//			AND4( \
//				EQ("X",SUBSTR_A("0","a")), \
//				EQ("Y",APPEND("X", CAT("Q","C"))), \
//				EQ(CHAR("C",0), CHAR_Ai(INCR(ADD("a",LEN("Q"))))), \
//				EQ("Q", SUBSTR_A(INCR("a"),ADD("a",LEN("Q")))) \
//			), \
//			EQ("Y", SUBSTR_A("0",INCR(ADD("a",LEN("Q"))))) \
//	   ), \
//	   PATT1(ANDPATT(EQ("X", SUBSTR_A("0","a")), EQ("Y", APPEND("X",CAT("Q","C"))))) \
//) "; "
//// substring equality
//FORALL(QUANT6(A,i,j,p,q,t), \
//	   IMPLIES( \
//	       AND6(EQ(SUBSTR_A("i","j"), SUBSTR_A("p","q")), LTE("i","t"),  LTE("t","j"), LT("i","j"), LT("p","q"), NEQ("i","p") ), \
//		   AND( EQ(CHAR_A(t), CHAR_Ai(ADD("t", SUB("p","i")))), EQ(SUB("q","p"),SUB("j","i")) ) \
//	   ), \
//	   PATT1(ANDPATT(CHAR_A(t), EQ(SUBSTR_A("i","j"), SUBSTR_A("p","q")))) \
//) "; "
//;